#!/usr/bin/perl

use IO::Socket;
use Net::hostent;              # for OO version of gethostbyaddr

# simple web server in Perl.

my $PORT = 8088;                  # pick something not in use

# create a socket.
my $server = IO::Socket::INET->new( Proto     => 'tcp',
                                  LocalPort => $PORT,
                                  Listen    => SOMAXCONN,
                                  Reuse     => 1);
# check for error.
die "can't setup server" unless $server;

print "[Server $0 accepting clients]\n";

while (my $client = $server->accept()) {
    $client->autoflush(1);  # no buffering.
    # get client address.
    my $hostinfo = gethostbyaddr($client->peeraddr);
    
   printf "[Connect from %s]\n", $hostinfo ? $hostinfo->name : $client->peerhost;

   print "read header\n";
    my ($get,$res,$ver) = split/\s+/,<$client>;

    print "header: $res\n";
    while(chomp($_ = <$client>)){
        s/\s+//sgi;
        last unless $_;
    }


    my ($ext) = ($res=~m/\.(.*?)$/is);
    print "finished header: $res; $ext\n";

    my %ctmap = (
        html => 'text/html',
        jpg => 'image/jpeg',
        txt => 'text/text',
    );
    my $ct = "text/html";
    $ct = $ctmap{$ext} if $ctmap{$ext};


    if(-f "public_html/$res"){
        print $client "HTTP/1.1 200 OK\n";
        print $client "Date: Mon, 08 Sep 2008 23:52:52 GMT\n";
        print $client "Server: Apache/2.0.54 (Win32) PHP/5.0.4\n";
        print $client "Connection: close\n";
        print $client "Content-Type: $ct\n";
        print $client "Content-Length: ".(-s "public_html/$res")."\n";
        print $client "\n";
        open my $in,"public_html/$res" or die $!;
        binmode $in;
        { local $/=undef; $_ = <$in>;}
        close $in;

        if($ext eq 'hph'){
            print "This is a script!!!\n";
            $_ = "?>$_<?hph";
            s|<\?=(.*?)\?>|<?hph print \$client "$1"; ?>|sgi;
            s|\?>(.*?)<\?hph|print \$client '$1';|sgi;
            eval($_);
        }else{
            print $client $_;
        }
    }else{
        $cont = "<html><body><h1>404 file not found</h1></body></html>\n";
        print $client "HTTP/1.1 404 Not Found\n";
        print $client "Date: Tue, 09 Sep 2008 00:05:47 GMT\n";
        print $client "Server: Apache/2.0.54 (Win32) PHP/5.0.4\n";
        print $client "Content-Length: ".length($cont)."\n";
        print $client "Connection: close\n";
        print $client "Content-Type: text/html; charset=iso-8859-1\n";
        print $client "\n";
        print $client "$cont";
    }
    close $client;
}

